<!--
 - Created by MarosGrajcar on 11/29/2019.
 -->

<!-- Eqt Data Update Create Read Update -->
<template>

    <template if:true={loading}>
        <lightning-spinner class="slds-is-relative slds-align--absolute-center" alternative-text="Loading"
                           size="medium"></lightning-spinner>
    </template>

    <!--MODAL-->
    <template if:true={openModal}>

        <section class="slds-modal slds-fade-in-open">
            <div class="slds-modal__container custom-modal_wide">
                <header class="slds-modal__header">
                    <button class="slds-button slds-button_icon slds-modal__close" title="Close"
                            onclick={formRejectModal}>
                        <lightning-icon icon-name="utility:close" size="medium">
                        </lightning-icon>
                        <span class="slds-assistive-text">Close</span>
                    </button>
                    <h2 class="slds-text-heading_medium slds-hyphenate">Add Equipment Form Rejection</h2>
                    <template if:true={loading}>
                        <lightning-spinner class="slds-is-relative slds-align--absolute-center slds-p-around--small"
                                           alternative-text="Loading" size="medium"></lightning-spinner>
                    </template>
                </header>
                <template if:false={loading}>
                    <div class="slds-modal__content slds-p-around_medium">
                        <lightning-textarea label="Reason for Rejection" value={reason}
                                            onchange={handleReason}></lightning-textarea>
                    </div>
                    <footer class="slds-modal__footer slds-text-align--left">
                        <lightning-button label="Submit" variant="brand" onclick={rejectForm}></lightning-button>
                        <lightning-button label="Cancel" variant="neutral"
                                          onclick={formRejectModal}></lightning-button>
                    </footer>
                </template>
            </div>
        </section>
        <div class="slds-backdrop slds-backdrop_open"></div>
    </template>

    <template if:false={loading}>

        <template if:true={isNewForm}>

            <!--INFORMATION-->
            <c-eqt_data_correction_header-information equipment={equipment}
                                                      expiration-date={expirationDate}
                                                      onequipmentstatus={setEquipmentStatus}>
            </c-eqt_data_correction_header-information>

            <!--DATA CORRECTION-->
            <c-eqt_data_correction-section equipment={equipment}></c-eqt_data_correction-section>

            <!--FILE-->
            <!--MEDIUM AND LARGE DEVICES-->
            <div class="slds-p-around--medium slds-show_medium">
                <lightning-input type="file"
                                 label="Attachment"
                                 onchange={handleAttachmentFileUpload}>
                </lightning-input>
                <template if:true={attachmentFileName}>
                    <p>{attachmentFileName}</p>
                </template>
            </div>

            <!--SMALL DEVICES-->
            <div class="slds-p-top-x--small slds-hide_medium">
                <lightning-input type="file"
                                 label="Attachment"
                                 onchange={handleAttachmentFileUpload}>
                </lightning-input>
                <template if:true={attachmentFileName}>
                    <p>{attachmentFileName}</p>
                </template>
            </div>


            <!-- ADDITIONAL INFORMATION -->
            <div class="slds-text-title_caps slds-section slds-p-around--small"
                 style="background-color:#f5f5f5"><b>Additional Information</b>
            </div>

            <!--MEDIUM AND LARGE DEVICES-->
            <div class="slds-wrap slds-grid slds-p-around--medium slds-show_medium">
                <div class="slds-size--6-of-12">
                    <lightning-input type="checkbox"
                                     label="Safety Critical Equipment"
                                     checked={safetyCriticalEq}
                                     onchange={handleSafetyCriticalEq}>
                    </lightning-input>
                </div>

                <div class="slds-size--6-of-12">
                    <lightning-input type="checkbox"
                                     label="Regulatory Equipment"
                                     checked={regulatoryEq}
                                     onchange={handleRegulatoryEq}>
                    </lightning-input>
                </div>
            </div>

            <!--SMALL DEVICES-->
            <div class="slds-p-top--xx-small slds-hide_medium">
                <lightning-input type="checkbox"
                                 label="Safety Critical Equipment"
                                 checked={safetyCriticalEq}
                                 onchange={handleSafetyCriticalEq}>
                </lightning-input>

                <lightning-input class="slds-p-top--small"
                                 type="checkbox"
                                 label="Regulatory Equipment"
                                 checked={regulatoryEq}
                                 onchange={handleRegulatoryEq}>
                </lightning-input>
            </div>

            <!--MEDIUM AND LARGE DEVICES-->
            <div class="slds-p-around--medium slds-show_medium">
                Expiration Date
                <p>
                    <lightning-formatted-date-time value={expirationDate}
                                                   year="numeric"
                                                   month="short"
                                                   day="2-digit">
                    </lightning-formatted-date-time>
                </p>
            </div>

            <!--SMALL DEVICES-->
            <div class="slds-p-top--small slds-hide_medium">
                Expiration Date
                <p>
                    <lightning-formatted-date-time value={expirationDate}
                                                   year="numeric"
                                                   month="short"
                                                   day="2-digit">
                    </lightning-formatted-date-time>
                </p>
            </div>

            <!--COMMENTS-->
            <c-eqt_comments-section is-user-admin={isUserAdmin} is-new-form={isNewForm}></c-eqt_comments-section>


            <!--ACTION BUTTONS-->
            <!--MEDIUM AND LARGE DEVICES-->
            <div class="slds-p-around--medium slds-card slds-align--absolute-center slds-show_medium">
                <lightning-button label="Save" variant="brand" onclick={getUserInputs}></lightning-button>
                <lightning-button label="Cancel" variant="neutral"
                                  onclick={closeForm}></lightning-button>
            </div>

            <!--SMALL DEVICES-->
            <div class="slds-p-around--medium slds-border--top slds-align--absolute-center slds-hide_medium">
                <lightning-button label="Save" variant="brand" onclick={getUserInputs}></lightning-button>
                <lightning-button label="Cancel" variant="neutral"
                                  onclick={closeForm}></lightning-button>
            </div>
        </template>

        <template if:false={isNewForm}>

            <!-- HEADER -->
            <!--MEDIUM AND LARGE DEVICES-->
            <div class="slds-grid slds-wrap slds-card slds-p-around--small slds-m-bottom--small slds-show_medium">
                <span class="slds-size--6-of-12">
                    <lightning-icon icon-name="custom:custom19"></lightning-icon>
                    <span class="slds-text-title_caps slds-p-left--x-small">
                        <b>Equipment Data Update Form</b> {equipmentForm.Name}
                    </span>
                </span>

                <template if:true={isView}>
                    <span if:false={formClosed} class="slds-size--6-of-12 slds-text-align--right slds-p-left--x-small">
                        <lightning-button label="Edit"
                                          variant="brand"
                                          onclick={editViewState}>
                        </lightning-button>

                        <lightning-button if:true={isUserAdmin}
                                          class="slds-p-right--x-small slds-p-left--x-small"
                                          label="Processed"
                                          variant="success"
                                          onclick={formProcessed}>
                        </lightning-button>

                        <lightning-button if:true={isUserAdmin}
                                          label="Reject"
                                          variant="destructive"
                                          onclick={formRejectModal}>
                        </lightning-button>
                    </span>
                </template>
            </div>

            <!--SMALL DEVICES-->
            <div class="slds-card slds-p-around--small slds-hide_medium">
                <lightning-icon class="slds-float--left" icon-name="custom:custom19"></lightning-icon>
                <lightning-button if:true={isView}
                                  class="slds-float--right"
                                  label="Edit"
                                  variant="brand"
                                  onclick={editViewState}>
                </lightning-button>
                <div class="slds-text-title_caps">
                    <b>Data Update Form</b>
                    <p>{equipmentForm.Name}</p>
                </div>
            </div>

            <div style="background-color:white">

                <!--INFORMATION-->
                <c-eqt_data_correction_header-information equipment-form={equipmentForm}
                                                          is-view={isView}
                                                          onequipmentstatus={setEquipmentStatus}>
                </c-eqt_data_correction_header-information>

                <template if:true={isView}>

                    <!--DATA CORRECTION-->
                    <c-eqt_data_correction-section equipment-form={equipmentForm}
                                                   is-view={isView}>
                    </c-eqt_data_correction-section>

                    <!--FILES-->
                    <!--MEDIUM AND LARGE DEVICES-->
                    <div class="slds-p-top--small slds-p-horizontal--medium slds-show_medium">
                        Attachment:
                        <p if:true={uploadedAttachmentFile}><a onclick={openFilePreview}
                                                               data-id={uploadedAttachmentFile.ContentDocumentId}>{uploadedAttachmentFile.ContentDocument.Title}</a>
                        </p>

                        <p if:true={uploadedAttachment}><a onclick={redirectToRecordPage}
                                                           data-id={uploadedAttachment.Id}
                                                           data-apiname="Attachment">{uploadedAttachment.Name}</a>
                        </p>
                    </div>

                    <!--SMALL DEVICES-->
                    <div class="slds-p-top--small slds-hide_medium">
                        Attachment
                        <p if:true={uploadedAttachmentFile}><a onclick={openFilePreview}
                                                               data-id={uploadedAttachmentFile.ContentDocumentId}>{uploadedAttachmentFile.ContentDocument.Title}</a>
                        </p>

                        <p if:true={uploadedAttachment}><a onclick={redirectToRecordPage}
                                                           data-id={uploadedAttachment.Id}
                                                           data-apiname="Attachment">{uploadedAttachment.Name}</a>
                        </p>
                    </div>

                    <!-- ADDITIONAL INFORMATION -->
                    <div class="slds-text-title_caps slds-section slds-p-around--small"
                         style="background-color:#f5f5f5"><b>Additional Information</b>
                    </div>

                    <!--MEDIUM AND LARGE DEVICES-->
                    <div class="slds-wrap slds-grid slds-p-around--medium slds-show_medium">
                        <div class="slds-size--6-of-12">
                            <lightning-input type="checkbox"
                                             label="Safety Critical Equipment"
                                             checked={equipmentForm.Safety_Critical_Equipment__c}
                                             disabled>
                            </lightning-input>

                            <div class="slds-p-top--small">
                                Expiration Date:
                                <p>
                                    <lightning-formatted-date-time value={equipmentForm.Expiration_Date__c}
                                                                   month="short"
                                                                   day="2-digit"
                                                                   year="numeric">
                                    </lightning-formatted-date-time>
                                </p>
                            </div>
                        </div>

                        <div class="slds-size--6-of-12">
                            <lightning-input type="checkbox"
                                             label="Regulatory Equipment"
                                             checked={equipmentForm.Regulatory_Equipment__c}
                                             disabled>
                            </lightning-input>
                        </div>
                    </div>

                    <!--SMALL DEVICES-->
                    <div class="slds-wrap slds-grid slds-hide_medium">
                        <div class="slds-size--6-of-12">
                            <lightning-input type="checkbox"
                                             label="Safety Critical Equipment"
                                             checked={equipmentForm.Safety_Critical_Equipment__c}
                                             disabled>
                            </lightning-input>

                            <div class="slds-p-top--small">
                                Expiration Date:
                                <p>
                                    <lightning-formatted-date-time value={equipmentForm.Expiration_Date__c}
                                                                   month="short"
                                                                   day="2-digit"
                                                                   year="numeric">
                                    </lightning-formatted-date-time>
                                </p>
                            </div>
                        </div>

                        <div class="slds-size--6-of-12">
                            <lightning-input type="checkbox"
                                             label="Regulatory Equipment"
                                             checked={equipmentForm.Regulatory_Equipment__c}
                                             disabled>
                            </lightning-input>
                        </div>
                    </div>

                    <!-- COMMENTS -->
                    <c-eqt_comments-section form={equipmentForm} is-user-admin={isUserAdmin} is-view={isView}></c-eqt_comments-section>

                    <!-- SYSTEM INFORMATION -->
                    <c-eqt_system-information-section equipment-form={equipmentForm}></c-eqt_system-information-section>

                </template>

                <template if:false={isView}>

                    <!-- DATA CORRECTION -->
                    <c-eqt_data_correction-section equipment-form={equipmentForm}
                                                   is-view={isView}
                                                   original-form={endpointForm}>
                    </c-eqt_data_correction-section>

                    <!--FILES-->
                    <!--MEDIUM AND LARGE DEVICES-->
                    <div class="slds-p-top--small slds-p-horizontal--medium slds-show_medium">
                        <template if:true={containsAttachment}>
                            Attachment:
                            <p if:true={uploadedAttachmentFile}><a onclick={openFilePreview}
                                                                   data-id={uploadedAttachmentFile.ContentDocumentId}>{uploadedAttachmentFile.ContentDocument.Title}</a>

                                <lightning-button-icon class="slds-p-left--medium" onclick={removeFile}
                                                       data-id={uploadedAttachmentFile.ContentDocumentId}
                                                       data-objecttype="file"
                                                       variant="bare"
                                                       icon-name="utility:close" alternative-text="Remove"
                                                       size="medium"></lightning-button-icon>
                            </p>
                            <p if:true={uploadedAttachment}><a onclick={redirectToRecordPage}
                                                               data-id={uploadedAttachment.Id}
                                                               data-apiname="Attachment">{uploadedAttachment.Name}</a>

                                <lightning-button-icon class="slds-p-left--medium" onclick={removeFile}
                                                       data-id={uploadedAttachment.Id}
                                                       data-objecttype="attachment"
                                                       variant="bare"
                                                       icon-name="utility:close" alternative-text="Remove"
                                                       size="medium"></lightning-button-icon>
                            </p>
                        </template>

                        <template if:false={containsAttachment}>
                            <lightning-input type="file"
                                             label="Attachment"
                                             onchange={handleAttachmentFileUpload}>
                            </lightning-input>
                            <template if:true={attachmentFileName}>
                                <p>{attachmentFileName}</p>
                            </template>
                        </template>
                    </div>

                    <!--SMALL DEVICES-->
                    <div class="slds-p-top--small slds-hide_medium">
                        <template if:true={containsAttachment}>
                            Attachment
                            <p if:true={uploadedAttachmentFile}><a onclick={openFilePreview}
                                                                   data-id={uploadedAttachmentFile.ContentDocumentId}>{uploadedAttachmentFile.ContentDocument.Title}</a>

                                <lightning-button-icon class="slds-p-left--medium" onclick={removeFile}
                                                       data-id={uploadedAttachmentFile.ContentDocumentId}
                                                       data-objecttype="file"
                                                       variant="bare"
                                                       icon-name="utility:close" alternative-text="Remove"
                                                       size="medium"></lightning-button-icon>
                            </p>
                            <p if:true={uploadedAttachment}><a onclick={redirectToRecordPage}
                                                               data-id={uploadedAttachment.Id}
                                                               data-apiname="Attachment">{uploadedAttachment.Name}</a>

                                <lightning-button-icon class="slds-p-left--medium" onclick={removeFile}
                                                       data-id={uploadedAttachment.Id}
                                                       data-objecttype="attachment"
                                                       variant="bare"
                                                       icon-name="utility:close" alternative-text="Remove"
                                                       size="medium"></lightning-button-icon>
                            </p>
                        </template>

                        <template if:false={containsAttachment}>
                            <lightning-input type="file"
                                             label="Attachment"
                                             onchange={handleAttachmentFileUpload}>
                            </lightning-input>
                            <template if:true={attachmentFileName}>
                                <p>{attachmentFileName}</p>
                            </template>
                        </template>
                    </div>

                    <!-- ADDITIONAL INFORMATION -->
                    <div class="slds-text-title_caps slds-section slds-p-around--small"
                         style="background-color:#f5f5f5"><b>Additional Information</b>
                    </div>

                    <div class="slds-wrap slds-grid slds-p-around--medium">
                        <div class="slds-size--6-of-12">
                            <lightning-input type="checkbox"
                                             label="Safety Critical Equipment"
                                             checked={equipmentForm.Safety_Critical_Equipment__c}
                                             onchange={handleSafetyCriticalEq}>
                            </lightning-input>

                            <div if:true={isUserAdmin} class="slds-p-top--small slds-size--4-of-12">
                                <p>
                                    <lightning-input label="Expiration Date"
                                                     type="date"
                                                     value={equipmentForm.Expiration_Date__c}
                                                     month="short"
                                                     day="2-digit"
                                                     year="numeric"
                                                     onchange={handleExpirationDate}>
                                    </lightning-input>
                                </p>
                            </div>

                            <div if:false={isUserAdmin} class="slds-p-top--small">
                                Expiration Date
                                <p>
                                    <lightning-formatted-date-time value={equipmentForm.Expiration_Date__c}
                                                                   month="short"
                                                                   day="2-digit"
                                                                   year="numeric">
                                    </lightning-formatted-date-time>
                                </p>
                            </div>
                        </div>

                        <div class="slds-size--6-of-12">
                            <lightning-input type="checkbox"
                                             label="Regulatory Equipment"
                                             checked={equipmentForm.Regulatory_Equipment__c}
                                             onchange={handleRegulatoryEq}>
                            </lightning-input>
                        </div>
                    </div>

                    <!-- COMMENTS -->
                    <c-eqt_comments-section form={equipmentForm} is-user-admin={isUserAdmin} is-view={isView} original-comments={equipmentForm}></c-eqt_comments-section>

                    <!--ACTION BUTTONS-->
                    <!--MEDIUM AND LARGE DEVICES-->
                    <div class="slds-p-around--medium slds-card slds-align--absolute-center slds-show_medium">
                        <lightning-button label="Submit" variant="brand" onclick={getUserInputs}></lightning-button>
                        <lightning-button label="Cancel" variant="neutral" onclick={cancelEditView}></lightning-button>
                    </div>

                    <!--SMALL DEVICES-->
                    <div class="slds-p-around--medium slds-border--top slds-align--absolute-center slds-hide_medium">
                        <lightning-button label="Submit" variant="brand" onclick={getUserInputs}></lightning-button>
                        <lightning-button label="Cancel" variant="neutral"
                                          onclick={closeForm}></lightning-button>
                    </div>

                </template>
            </div>

        </template>

    </template>
</template>